#include "SineSynth.h"

#include <iostream>

Generator::Generator(uint32_t _sampleRate, float _frequency, float _amplitude) : sampleRate(_sampleRate), frequency(_frequency), amplitude(_amplitude)
{
}

Generator::~Generator()
{
}

SineGenerator::SineGenerator(uint32_t _sampleRate, float _frequency, float _amplitude = 1) : Generator(_sampleRate, _frequency, _amplitude), tick(0) {
    phaseIncr = 2 * M_PI * frequency / sampleRate;

    std::cout << "Constructed SineGenerator with freq " << frequency << " phaseIncr " << phaseIncr << std::endl;
}

SineGenerator::~SineGenerator() {

}

void SineGenerator::getSamples(uint16_t nSamples, float *buf) {
    for (;nSamples>0;nSamples--) {
        std::cout << "Generating tick " << tick << std::endl;
        *buf++ = cos(phaseIncr * tick++) * amplitude;
    }
}